#!/usr/bin/env python3
import sys
assert sys.version_info[0] >= 3, "Python 3 required."

def label_to_nl(label_file, nl_file, range_min, range_max):
    labels = open(label_file, "rt").readlines()
    labs = {}
    sout = ""
    for line in labels:
        words = line.split()
        if (words[0] == "al"):
            adr = int(words[1], 16)
            sym = words[2]
            sym = sym.lstrip('.')
            if (sym[0] == '_' and sym[1] == '_'):
                continue # skip compiler internals
            if (adr >= range_min and adr <= range_max):
                if (adr in labs):
                    # multiple symbol
                    text = labs[adr]
                    textsplit = text.split()
                    if (sym not in textsplit):
                        text = text + " " + sym
                        labs[adr] = text
                else:
                    labs[adr] = sym
    for (adr, sym) in labs.items():
        sout += ("$%04X#%s#\n" % (adr, sym))
    open(nl_file, "wt").write(sout)
    print("debug symbols: " + nl_file)

if __name__ == "__main__":
    label_to_nl("temp\\00_01.labels.txt", "temp\\pico.nes.ram.nl", 0x0000, 0x7FFF)
    label_to_nl("temp\\00_01.labels.txt", "temp\\pico.nes.0.nl",   0x8000, 0x9FFF)
    label_to_nl("temp\\7F.labels.txt", "temp\\pico.nes.1F.nl", 0xF000, 0xFFFF)
